From c9b46d8102e35a2e51f8b4d02badb78a06371619 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 29 Jun 2020 06:52:42 +0300
Subject: [PATCH 23/59] AlpineApkAuthHelper: create event loop only when needed

It fixes error "QEventLoop: requires QApplication",
this makes it creation delayed to moment *after*
QCoreApplication object is created by KAuthCore
internals.
---
 .../AlpineApkBackend/AlpineApkAuthHelper.cpp       | 14 +++++++++-----
 .../AlpineApkBackend/AlpineApkAuthHelper.h         |  2 +-
 2 files changed, 10 insertions(+), 6 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index 81c18255c..b436aa73b 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -78,6 +78,10 @@ void AlpineApkAuthHelper::setupTransactionPostCreate(QtApk::Transaction *trans)
     // what to do when transaction is complete
     QObject::connect(trans, &QtApk::Transaction::finished,
                      this, &AlpineApkAuthHelper::onTransactionFinished);
+
+    if (!m_loop) {
+        m_loop = new QEventLoop(this);
+    }
 }
 
 void AlpineApkAuthHelper::reportProgress(float percent)
@@ -106,7 +110,7 @@ void AlpineApkAuthHelper::onTransactionFinished()
     m_lastChangeset = m_currentTransaction->changeset();
     m_currentTransaction->deleteLater();
     m_currentTransaction = nullptr;
-    m_loop.quit();
+    m_loop->quit();
 }
 
 ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
@@ -126,7 +130,7 @@ ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
     setupTransactionPostCreate(trans);
 
     trans->start();
-    m_loop.exec();
+    m_loop->exec();
 
     if (m_trans_ok) {
         int updatesCount = m_apkdb.upgradeablePackagesCount();
@@ -165,7 +169,7 @@ ActionReply AlpineApkAuthHelper::add(const QVariantMap &args)
     setupTransactionPostCreate(trans);
 
     trans->start();
-    m_loop.exec();
+    m_loop->exec();
 
     if (m_trans_ok) {
         m_actionReply = ActionReply::SuccessReply();
@@ -207,7 +211,7 @@ ActionReply AlpineApkAuthHelper::del(const QVariantMap &args)
     setupTransactionPostCreate(trans);
 
     trans->start();
-    m_loop.exec();
+    m_loop->exec();
 
     if (m_trans_ok) {
         m_actionReply = ActionReply::SuccessReply();
@@ -243,7 +247,7 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
     setupTransactionPostCreate(trans);
 
     trans->start();
-    m_loop.exec();
+    m_loop->exec();
 
     if (m_trans_ok) {
         m_actionReply = ActionReply::SuccessReply();
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
index acce56488..eed39f283 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.h
@@ -53,7 +53,7 @@ protected Q_SLOTS:
 private:
     QtApk::DatabaseAsync m_apkdb; // runs transactions in bg thread
     QtApk::Transaction *m_currentTransaction = nullptr;
-    QEventLoop m_loop; // event loop that will run and wait while bg transaction is in progress
+    QEventLoop *m_loop = nullptr; // event loop that will run and wait while bg transaction is in progress
     ActionReply m_actionReply; // return value for main action slots
     bool m_trans_ok = true; // flag to indicate if bg transaction was successful
     QtApk::Changeset m_lastChangeset; // changeset from last completed transaction
-- 
GitLab


